unit TDM47Impl1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, TDM47_TLB, ExtCtrls, DBCtrls, StdCtrls, Db, Mask,
  DBTables;

type
  TTDM47X = class(TActiveForm, ITDM47X)
    TableBIOLIFE: TTable;
    TableBIOLIFESpeciesNo: TFloatField;
    TableBIOLIFECategory: TStringField;
    TableBIOLIFECommon_Name: TStringField;
    TableBIOLIFESpeciesName: TStringField;
    TableBIOLIFELengthcm: TFloatField;
    TableBIOLIFELength_In: TFloatField;
    TableBIOLIFENotes: TMemoField;
    TableBIOLIFEGraphic: TGraphicField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    DataSource1: TDataSource;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBMemo1: TDBMemo;
    DBImage1: TDBImage;
    DBNavigator1: TDBNavigator;
  private
    { Private declarations }
    FEvents: ITDM47XEvents;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);
  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Get_Active: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_BiDiMode: TxBiDiMode; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    procedure _Set_Font(const Value: IFontDisp); safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_BiDiMode(Value: TxBiDiMode); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(var Value: IFontDisp); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
  public
    { Public declarations }
    procedure Initialize; override;
  end;

implementation

uses ComObj, ComServ;

{$R *.DFM}

{ TTDM47X }

procedure TTDM47X.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_TDM47XPage); }
end;

procedure TTDM47X.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as ITDM47XEvents;
end;

procedure TTDM47X.Initialize;
begin
  inherited Initialize;
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;
end;

function TTDM47X.Get_Active: WordBool;
begin
  Result := Active;
end;

function TTDM47X.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TTDM47X.Get_AutoSize: WordBool;
begin
  Result := AutoSize;
end;

function TTDM47X.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TTDM47X.Get_BiDiMode: TxBiDiMode;
begin
  Result := Ord(BiDiMode);
end;

function TTDM47X.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TTDM47X.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(Color);
end;

function TTDM47X.Get_Cursor: Smallint;
begin
  Result := Smallint(Cursor);
end;

function TTDM47X.Get_DoubleBuffered: WordBool;
begin
  Result := DoubleBuffered;
end;

function TTDM47X.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TTDM47X.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TTDM47X.Get_Font: IFontDisp;
begin
  GetOleFont(Font, Result);
end;

function TTDM47X.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TTDM47X.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TTDM47X.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TTDM47X.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TTDM47X.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TTDM47X.Get_Visible: WordBool;
begin
  Result := Visible;
end;

procedure TTDM47X._Set_Font(const Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TTDM47X.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TTDM47X.Set_AutoSize(Value: WordBool);
begin
  AutoSize := Value;
end;

procedure TTDM47X.Set_AxBorderStyle(Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TTDM47X.Set_BiDiMode(Value: TxBiDiMode);
begin
  BiDiMode := TBiDiMode(Value);
end;

procedure TTDM47X.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TTDM47X.Set_Color(Value: OLE_COLOR);
begin
  Color := TColor(Value);
end;

procedure TTDM47X.Set_Cursor(Value: Smallint);
begin
  Cursor := TCursor(Value);
end;

procedure TTDM47X.Set_DoubleBuffered(Value: WordBool);
begin
  DoubleBuffered := Value;
end;

procedure TTDM47X.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TTDM47X.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TTDM47X.Set_Font(var Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TTDM47X.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TTDM47X.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TTDM47X.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TTDM47X.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TTDM47X.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TTDM47X.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

procedure TTDM47X.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TTDM47X.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TTDM47X.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TTDM47X.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TTDM47X.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TTDM47X.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TTDM47X.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TTDM47X.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TTDM47X,
    Class_TDM47X,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.
